﻿;;;-*- Mode: Lisp; Package: "MOSS" -*-
;;;==========================================================================
;;;14/03/07
;;;		
;;;		P A T C H E S - (File moss-patches.lisp)
;;;		Copyright Barthes@Compiegne 2010-2014
;;;	
;;;==========================================================================

;;; the file is loaded after the main compiled files. Since the distributed 
;;; version of MOSS does not contain the compiler, the source is loaded, 
;;; meaning that the functions will be interpreted rather than compiled, which
;;; is not crucial in general since it concerns a few functions only.

;;; Patches are contained in a special folder, and concern the previous release
;;; version of the platform. Therefore, they should be loaded only if the name
;;; of the folder is the same as the version of the platform
;;; The name of the folder is "mos-patches-v8.0.8" and the patches files 
;;; inside the folder are names P8.0.8.0, P8.0.8.1, ... All files are loaded 
;;; in this order

#|
2014
 0307 -> UTF8 ontologies
|#

(in-package :moss)

(eval-when (:compile-toplevel :load-toplevel :execute)
  
  (defParameter *patch-folder*
    (make-pathname  :directory (append
                                (pathname-directory *MOSS-DIRECTORY-PATHNAME*)
                                (list "MOSS source"
                                      (format nil "moss-patches-v~A" 
                                              *moss-version-number*)))
                    :name :wild
                    :type "lisp"
                    :defaults *MOSS-DIRECTORY-PATHNAME*))
  
  ;;; should get the names of the files inside the folder
  (defParameter *patch-file-list* (directory *patch-folder*))
  
  ;;; load patches for this version
  
  (when *patch-file-list*
    (dolist (patch *patch-file-list*)
      ;(print patch)
      (load patch :external-format :utf-8)))
  )

(format t "~%;*** MOSS v~A - Patches loaded ***" *moss-version-number*)